#!/usr/bin/env python
#coding=utf8

import os
import glob
import time

#os.system('modprobe w1-gpio')
#os.system('modprobe w1-therm')

if not os.path.isdir('/sys/bus/w1'):
    print("Включите поддержку 1-Wire в  конфигурации Raspberry!")
    exit()
    
base_dir = '/sys/bus/w1/devices/'
device_folders = glob.glob(base_dir + '28*')

#Функция чтения значения температуры с указанного термометра
def read_temp_raw(device_file):
    '''Читает значение температуры с указанного термометра и возвращает его.
       device_file - папка (с полным путем), в которой находятся данные термометра '''
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    equals_pos = lines[1].find('t=')
    temp_string = lines[1][equals_pos+2:]
    temp_c = float(temp_string) / 1000.0
    return (temp_c)
    
#Возвращает кортеж из списка кортежей названий термометров с температурами
#и времени измерения
def Measure():
    DS18B20list=[]
    while True:
        time_b=time.time()
        for device in device_folders:
            device_file = device + '/w1_slave'
            DS18B20list.append((os.path.basename(device),
                               read_temp_raw(device_file)))
        return (DS18B20list, (time.time()-time_b))

def main():
    while True:
        (DS18B20list, tMeasure)=Measure()
        for DS18B20 in DS18B20list:
            print(u"%s\t%3.1f градC" % DS18B20)
        print(u'Время измерения=%ssec' % tMeasure)
        print('')

if __name__ == '__main__':
    main()

        
